"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Netcd = exports.types = void 0;
const index_1 = require("./interface/election/index");
const index_2 = require("./interface/lock/index");
const index_3 = require("./interface/rpc/index");
const grpc = __importStar(require("@grpc/grpc-js"));
exports.types = __importStar(require("./types"));
__exportStar(require("@grpc/grpc-js"), exports);
const serviceMap = {
    Election: index_1.Election,
    Lock: index_2.Lock,
    KV: index_3.KV, Watch: index_3.Watch, Lease: index_3.Lease, Cluster: index_3.Cluster, Maintenance: index_3.Maintenance, Auth: index_3.Auth
};
class Netcd {
    clientConfig;
    serviceInstanceMap = new Map();
    constructor(clientConfig) {
        this.clientConfig = clientConfig;
    }
    randomEndpoint() {
        const randomIndex = Math.floor(Math.random() * this.clientConfig.endpoints.length);
        return this.clientConfig.endpoints[randomIndex];
    }
    getClient(clientName) {
        if (!serviceMap[clientName]) {
            throw new Error(`clientName only have ${Object.keys(serviceMap).join()}`);
        }
        if (this.serviceInstanceMap.has(clientName)) {
            return this.serviceInstanceMap.get(clientName);
        }
        this.serviceInstanceMap.set(clientName, new serviceMap[clientName](this.randomEndpoint(), grpc.credentials.createInsecure()));
        return this.serviceInstanceMap.get(clientName);
    }
}
exports.Netcd = Netcd;
