"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const assert = __importStar(require("assert"));
const mocha_1 = require("mocha");
const grpc = __importStar(require("@grpc/grpc-js"));
const index_1 = require("../index");
const protoLoader = __importStar(require("@grpc/proto-loader"));
const RPC_PROTO_PATH = path.join(path.dirname(__dirname), 'protos/rpc.proto');
const rpcPackageDefinition = protoLoader.loadSync(RPC_PROTO_PATH);
const etcdserverpb = grpc.loadPackageDefinition(rpcPackageDefinition).etcdserverpb;
const port = '50051';
const netcd = new index_1.Netcd({
    endpoints: [`127.0.0.1:${port}`]
});
const server = new grpc.Server();
// @ts-ignore
server.addService(etcdserverpb.KV.service, {
    Range: (call, callback) => {
        callback(null, {
            "header": {
                "cluster_id": "14841639068965178418",
                "member_id": "10276657743932975437",
                "revision": "2",
                "raft_term": "3"
            },
            "kvs": [
                {
                    "key": call.request.key,
                    "create_revision": "2",
                    "mod_revision": "2",
                    "version": "1",
                    "value": Buffer.from("test_value")
                }
            ],
            "count": "1"
        });
    }
});
// @ts-ignore
server.addService(etcdserverpb.Auth.service, {
    Authenticate: (call, callback) => {
        callback(null, {
            "header": {
                "cluster_id": "14841639068965178418",
                "member_id": "10276657743932975437",
                "revision": "2",
                "raft_term": "3"
            },
            "token": 'testtoken.01',
            "count": "1"
        });
    }
});
server.bindAsync(`127.0.0.1:${port}`, grpc.ServerCredentials.createInsecure(), () => {
    server.start();
});
(0, mocha_1.describe)('KV', function () {
    (0, mocha_1.describe)('#Range()', function () {
        (0, mocha_1.it)('get Range return test data', async function () {
            const authClient = netcd.getClient('Auth');
            const authData = await new Promise((reslove, reject) => {
                authClient.Authenticate({ "name": "root", "password": "a123456" }, (err, data) => {
                    if (err)
                        return reject(err);
                    reslove(data);
                });
            });
            assert.equal(authData.token, 'testtoken.01', 'get token error');
            const client = netcd.getClient('KV');
            const meta = new index_1.Metadata();
            meta.add('Authorization', authData.token);
            const res = await new Promise((reslove, reject) => {
                client.Range({ key: Buffer.from('test_key').toString('base64') }, meta, (err, data) => {
                    if (err)
                        return reject(err);
                    reslove(data);
                });
            });
            assert.equal(res.kvs[0].value.toString(), 'test_value', 'get Range error');
        });
    });
});
(0, mocha_1.after)(() => {
    server.tryShutdown((error) => {
        console.log(error);
    });
});
